
// Matrici

public class Esempio1Sol {
	
	static void stampaMatrice(int[][] m) {
		int i,j;
		for (i = 0 ; i < m.length ; i++) {
			for (j = 0 ; j < m[i].length ; j++) {
				System.out.print(m[i][j] + "   ");
			}
			System.out.println();  // Vai a capo
		}
	}

	static int[][] somma(int[][] m1, int[][] m2) {
		int m3[][];
		m3 = new int[m1.length][m1[0].length];  // uso le stesse dimensioni
		int i;
		int j;
		for (i = 0 ; i < m1.length ; i++) {
			for (j = 0 ; j  < m1[i].length ; j++) {
				m3[i][j] = m1[i][j] + m2[i][j];
			}
		}
		return m3;
	}

	static int[][] trasposta(int[][] m) {
		int tr[][];
		tr = new int[m[0].length][m.length];   // dimensioni rovesciate
		int i;
		int j;
		for (i = 0 ; i < tr.length ; i++) {
			for (j = 0 ; j  < tr[i].length ; j++) {
				tr[i][j] = m[j][i];
			}
		}
		return tr;
	}
	
	
	public static void main(String[] args) {
		
		// Le matrici in Java sono "vettori di vettori".
		int[][] m;
		m = new int[3][]; // 3 righe

		m[0] = new int[4];  // 4 colonne
		m[1] = new int[4];  // 4 colonne
		m[2] = new int[4];  // 4 colonne
		 
		// Si potrebbe anche usare un for per allocare le singole righe.
		// C'è comunque un modo ancora più semplice, che vediamo tra poco.
		
		// Inizializziamo la matrice
		int i,j;
		for (i = 0 ; i < m.length ; i++) {
			for (j = 0 ; j < m[i].length ; j++) {
				// m[i][j] è l'elemento in riga i e colonna j
				m[i][j] = 10*i+j;
			}
		}
		// Si noti come m.length sia il numero di righe, e m[i].length
		// la lunghezza della righa i, cioè il numero di colonne.
		
		// Stampiamo
		stampaMatrice(m);
		
		// Esiste anche un modo più breve per allocare l'intera matrice.
		int [][] m2;
		m2 = new int[3][4];
		// Questo è perfettamente equivalente a fare tutte le new che abbiamo
		// fatto sopra manualmente.
		
		
		for (i = 0 ; i < m.length ; i++) {
			for (j = 0 ; j < m[i].length ; j++) {
				// m[i][j] è l'elemento in riga i e colonna j
				m2[i][j] = 100*j+i;
			}
		}
		
		System.out.println("--------------");
		stampaMatrice(m2);
		System.out.println("--------------");
		
		
		// Esercizio 1.
		// Si sviluppi una funzione
		//    static int[][] somma(int[][] m1, int[][] m2)
		// che calcoli la somma delle due matrici m1 e m2.
		
		// Soluzione
		
		int s[][];
		s = somma(m, m2);
		
		System.out.println("--------------");
		stampaMatrice(s);
		System.out.println("--------------");
		
		// Esercizio 2.
		// Si sviluppi una funzione
		//    static int[][] trasposta(int[][] m)
		// che calcoli la trasposta della matrice m.
		
		// Soluzione
		
		int tr[][];
		tr = trasposta(m);
		
		System.out.println("--------------");
		stampaMatrice(tr);
		System.out.println("--------------");
		
	}
}
