
// Record

public class Esempio2Sol {
	
	record Persona(String nome, int età) {}
	
	static Persona piùGiovane(Persona[] persone) {
		Persona giovane;
		giovane = persone[0];
		int i;
		for (i = 1 ; i < persone.length ; i++) {
			if (persone[i].età < giovane.età) {
				giovane = persone[i];
			}
		}
		return giovane;
	}
	
	static void stampaPersone(Persona[] persone) {
		int i;
		for (i = 0 ; i < persone.length ; i++) {
			System.out.println(persone[i]);
		}
	}
	
	record Metri(double valore) {}
	record Secondi(double valore) {}
	
	// È possibile definire funzioni con lo stesso nome ma tipi diversi
	static Metri somma(Metri x, Metri y) {
		return new Metri(x.valore + y.valore);
	}

	static Secondi somma(Secondi x, Secondi y) {
		return new Secondi(x.valore + y.valore);
	}
	
	record Velocità(double valore) {}
	
	static Velocità somma(Velocità x, Velocità y) {
		return new Velocità(x.valore + y.valore);
	}
	
	static Velocità divisione(Metri m, Secondi s) {
		return new Velocità(m.valore / s.valore);
	}

	static Metri moltiplicazione(Velocità v, Secondi s) {
		return new Metri(v.valore * s.valore);
	}

	
	public static void main(String[] args) {
		
		System.out.println("--------------");
		System.out.println("--------------");
		System.out.println("--------------");
		
		// Un Java record è essenzialmente una n-upla di valori.
		Persona p;
		// Per creare una tupla nuova va usato "new".
		p = new Persona("Luigi", 32);
		// Si può stampare tutta la tupla semplicemente così:
		System.out.println(p);
		// Si può accedere alle componenti così:
		System.out.println(p.nome);
		System.out.println(p.età);
		// Le componenti sono immutabili, non si possono modificare
		// direttamente.
		//     p.nome = "Luigino"; // Errore!
		// Si possono però creare nuove n-uple.
		p = new Persona("Luigino", p.età);
		System.out.println(p);
		
		System.out.println("--------------");
		
		Persona[] persone;
		persone = new Persona[5];
		persone[0] = new Persona("Mario", 25);
		persone[1] = new Persona("Giuseppe", 75);
		persone[2] = new Persona("Lucia", 23);
		persone[3] = new Persona("Silvia", 65);
		persone[4] = new Persona("Augusto", 45);

		stampaPersone(persone);

		Persona giovane;
		giovane = piùGiovane(persone);
		System.out.println("Il più giovane: " + giovane);
		
		// Java usa un sistema di tipi "nominale": i tipi record con
		// nome diverso sono diversi anche se le n-uple contengono
		// le stesse componenti.
		
		Metri m;
		m = new Metri(42.42);
		Secondi s;
		s = new Secondi(10.32);
		// m = s; // Errore!
		
		// Possiamo quindi definire due funzioni somma che non 
		// consentono di mischiare le unità di misura.
		m = somma(m,m);
		s = somma(s,s);
		// somma(m,s); // Errore!
		
		// Esercizio 1.
		// Aggiungete un record Velocità che rappresenta metri al secondo.
		// Create opportune operazioni per consentire somme, prodotti
		// e divisioni dove ha senso farlo (e non dove non avrebbe senso).
		
	}

}
